//TStringLongIntList Class
#ifndef TStringLongIntListH
#define TStringLongIntListH
#include "AnsiString.h"
#include <stdio.h>

#define COUNTMAX 0x7FFFFFFA	//the absolut maximum of line count.

class TStringLongIntList;

class StringIntElem{
  public:
	TStringLongIntList* Own;
	StringIntElem(){}
	~StringIntElem(){}
	AnsiString& operator[] (long i);
	AnsiString& operator[] (unsigned i);
	AnsiString& operator[] (int i);
};

class IntElem{
  public:
	TStringLongIntList* Own;
	IntElem(){}
	~IntElem(){}
	int& operator[] (long i);
	int& operator[] (unsigned i);
	int& operator[] (int i);
};

class LongElem{
  public:
	TStringLongIntList* Own;
	LongElem(){}
	~LongElem(){}
	long& operator[] (long i);
	long& operator[] (unsigned i);
	long& operator[] (int i);
};

class TextIntElem{
  public:
	AnsiString Element;
	int IntElem;
	long LongElem;
	TextIntElem* FW;
	TextIntElem* BK;
	TextIntElem(){}
	~TextIntElem(){}
};

class TStringLongIntList{
	TextIntElem* Root;
	TextIntElem* Tail;
	TextIntElem* Act;
	long ActIndex;
  public:
	TStringLongIntList();
	~TStringLongIntList();
	long Count;
	StringIntElem Strings;
	IntElem Ints;
	LongElem Longs;
	bool LoadFromFile(char* fname);
	bool LoadFromFile(AnsiString& fname);
	bool SaveToFile(char* fname);
	bool SaveToFile(AnsiString& fname);
	void Insert(long i, char* str);
	void Insert(long index, AnsiString str);
	void Delete(long i);
	void Insert(unsigned i, char* str);
	void Insert(unsigned index, AnsiString str);
	void Delete(unsigned i);
	void Delete(int i);
	void Clear();
	void Add(AnsiString str);
	void Add(char* str);
	void Add(AnsiString str,int Int,long Long);
	void Add(char* str,int Int,long Long);
	TextIntElem* GetElemByIndex(long i);
};

#endif
