//TabControl
#include "TabControl.h"
extern int IDord;

TabControl::TabControl(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size){
	GRhwnd=CreateWindow(WC_TABCONTROLA,Caption, WS_CHILD|WS_VISIBLE,
				Size[0],Size[1],Size[2],Size[3],
                hwnd, (HMENU)IDord, hinst, 0 );
	IDord++;
	hFont=NULL;
	TabCnt=0;
	
	TabControlProcAddr = (WNDPROC)GetWindowLong(GRhwnd, GWL_WNDPROC);
	SetWindowLong(GRhwnd, GWL_WNDPROC, reinterpret_cast<LONG_PTR>(&TabControl::StatWndProc));
}

TabControl::~TabControl(){
	if(hFont)DeleteObject(hFont);
}

void TabControl::SetDefFont(){
	hFont = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	SendMessage(GRhwnd,WM_SETFONT ,(WPARAM)hFont,true);
}

void TabControl::AddTab(char*name){
	TabDef.mask=TCIF_TEXT;
	TabDef.pszText=name;
	TabDef.cchTextMax=strlen(name);
	TabDef.iImage=-1;
	SendMessage(GRhwnd,TCM_INSERTITEM,TabCnt++,(LPARAM)&TabDef);
}

void TabControl::DeleteTab(int tab){
	SendMessage(GRhwnd,TCM_DELETEITEM,tab,0);
}
