//TrackBar
#include "TrackBar.h"
extern int IDord;

TrackBar::TrackBar(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size,int VerHorz){
	//InitCommonControls();
	DWORD Style;
	if(VerHorz==HORZ){
		Style=WS_CHILD | WS_VISIBLE | TBS_AUTOTICKS | TBS_ENABLESELRANGE;
	}else{
		Style=WS_CHILD | WS_VISIBLE | TBS_AUTOTICKS | TBS_ENABLESELRANGE | TBS_VERT;
	}
	
    TrackBarHwnd = CreateWindowEx( 
			0,                      // no extended styles 
			TRACKBAR_CLASS,         // class name 
			"Trackbar Control",     // title (caption) 
			Style,
			Size[0],              	// horizontal position 
			Size[1], 				// vertical position 
			Size[2],             	// width of the Track bar 
			Size[3],               	// height of the Track bar
			hwnd,             		// handle to main window 
			(HMENU) NULL,           // no menu 
			hinst,                	// instance owning this window 
			(PVOID) NULL            // pointer not needed 
	); 

    SendMessage(TrackBarHwnd, TBM_SETRANGE, 
        (WPARAM) TRUE,                   // redraw flag 
        (LPARAM) MAKELONG(0, 100));      // min. & max. positions
        
    SendMessage(TrackBarHwnd, TBM_SETPAGESIZE, 
        0, (LPARAM) 5);                  // new page size 

	/*
    SendMessage(TrackBarHwnd, TBM_SETSEL, 
        (WPARAM) FALSE,                  // redraw flag 
        (LPARAM) MAKELONG(0, 100)); 
	*/
        
    SendMessage(TrackBarHwnd, TBM_SETPOS, 
        (WPARAM) TRUE,                   // redraw flag 
        (LPARAM) 0);
		
    ID=IDord++;
	
	TrackBarProcAddr = (WNDPROC)GetWindowLong(TrackBarHwnd, GWL_WNDPROC);
	SetWindowLong(TrackBarHwnd, GWL_WNDPROC, reinterpret_cast<LONG_PTR>(&TrackBar::StatWndProc));
}

TrackBar::~TrackBar(){
}

void TrackBar::SetPos(int pos){
	SendMessage(TrackBarHwnd, TBM_SETPOS, (WPARAM) TRUE, (LPARAM) pos);
}

int TrackBar::GetPos(){
	return SendMessage(TrackBarHwnd,TBM_GETPOS,0,0);
}
