//MainForm
#include "MainForm.h"


MainForm::MainForm(char * AppName,int StX,int StY){
	Create(AppName,StX,StY);

//user code here	

}

MainForm::~MainForm(){
//user code here

    DestroyForm();
}

//Build up form
void MainForm::BuildForm(HWND hwnd,HINSTANCE hInst){
    Button01=new Button(hwnd,hInst,"B1",Button01Param);
    Button02=new Button(hwnd,hInst,"B2",Button02Param);
 
    Canvas=new CanvasClass(hwnd, 500,500);
}

//Destroy form
void MainForm::DestroyForm(){
 	delete Button01;
    delete Button02;
	
	delete Canvas;
}

void MainForm::OnCommand(WORD command){
//     REGCALLBK(Button01) Button1Click();

}

void MainForm::OnPaint(){
	Canvas->Repaint();
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************
static int sX=-1,sY=-1,W=10,H=10;
static int Lbtn=0,Rbtn=0;
static int megfogva=0,Rx,Ry;
void MainForm::OnMouseButton(int X, int Y){
	Lbtn=1;
	RECT r;
	r.top=0;
	r.left=0;
	r.right=500;
	r.bottom=500;
	Canvas->Brush->Color=0x000000;
	Canvas->FillRect(r);
	
	if((sX==-1)||(sY==-1)){
		r.top=Y;
		r.left=X;
		r.right=X+W;
		r.bottom=Y+H;
		sX=X;sY=Y;
		Canvas->Brush->Color=0x00FF00;
		Canvas->FillRect(r);
		Canvas->Update();
	}else{
		if((X>=sX)&&(Y>=sY)&&(X<=sX+W)&&(Y<=sY+H)){
			megfogva=1;Rx=X-sX;Ry=Y-sY;
		}else megfogva=0;
	}	
}

void MainForm::OnMouseButtonUp(int X, int Y){
	Lbtn=0;
}

void MainForm::OnMouseDbClick(int X,int Y){
	if((X>=sX)&&(Y>=sY)&&(X<=sX+W)&&(Y<=sY+H)){
		char msg[100];
		sprintf(msg,"STX,STY,WI,HEI={%d,%d,%d,%d}",sX,sY,W,H);
		ShowMessage(msg);
		FILE*f;
		int w;
		f=fopen("params.txt","wb");
		for(w=0;w<100;w++){
			if(!msg[w]){
				fputc(13,f);fputc(10,f);
				break;
			}
			fputc(msg[w],f);
		}
		fclose(f);
	}
}

void MainForm::OnMouseMove(int X,int Y){
	RECT r;
	
	if(Lbtn&&megfogva){
		r.top=0;
		r.left=0;
		r.right=500;
		r.bottom=500;
		Canvas->Brush->Color=0x000000;
		Canvas->FillRect(r);

		sX=X-Rx;
		sY=Y-Ry;
		if(sX<0)return;
		if(sY<0)return;
		r.top=sY;
		r.left=sX;
		r.right=sX+W;
		r.bottom=sY+H;

		Canvas->Brush->Color=0x00FF00;
		Canvas->FillRect(r);
		Canvas->Update();
	}
	if(Rbtn){
		if((W=X-sX)<=0)return;
		if((H=Y-sY)<=0)return;
		RECT r;
		r.top=0;
		r.left=0;
		r.right=500;
		r.bottom=500;
		Canvas->Brush->Color=0x000000;
		Canvas->FillRect(r);
		r.top=sY;
		r.left=sX;
		r.right=sX+W;
		r.bottom=sY+H;
		if(W<10)return;
		if(H<10)return;
		Canvas->Brush->Color=0x00FF00;
		Canvas->FillRect(r);
		Canvas->Update();
	}
}

void MainForm::OnMouseRightBtn(int X,int Y){
	Rbtn=1;
	if((W=X-sX)<=0)return;
	if((H=Y-sY)<=0)return;
	RECT r;
	r.top=0;
	r.left=0;
	r.right=500;
	r.bottom=500;
	Canvas->Brush->Color=0x000000;
	Canvas->FillRect(r);
	r.top=sY;
	r.left=sX;
	r.right=sX+W;
	r.bottom=sY+H;
	Canvas->Brush->Color=0x00FF00;
	Canvas->FillRect(r);
	Canvas->Update();
}

void MainForm::OnMouseRightBtnUp(int X,int Y){
	Rbtn=0;
}
