//AudioRecorder Class
#ifndef AudioRecClassH
#define AudioRecClassH

#include <windows.h>
#include <mmsystem.h>
//MUST BE LINKED WITH WinMM.Lib !

#define BLOCK_SIZE_REC 8192
#define BLOCK_COUNT_REC 2

static WAVEHDR* waveBlocks_REC;
static volatile unsigned int waveActualBlock_REC;

class AudioRecorder{
public:
	AudioRecorder(HWND hwnd);
	~AudioRecorder();
	
	int error;	//flag to show error occured
	
	void StartRec();
	void StopRec();
	unsigned char* GetRecData();
	unsigned char* RECdata;
	
private:
	WAVEFORMATEX wfx;
	HWAVEIN hWaveIn;
	HWND OwnerHwnd;
	int RunRecord;
 
	WAVEHDR* allocateBlocks(int size, int count);
	void freeBlocks(WAVEHDR* blockArray);
	
};

#endif
