//NetworkIterface

//WARNING!!
//In DEV C++ you should link WS2_32.lib
//Setup your makefile in project options
//modify this line to:
//LIBS =  -L"C:/Dev-Cpp/lib" -mwindows -lWS2_32

#ifndef NetworkIterfaceH
#define NetworkIterfaceH

#undef UNICODE
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#include "ThreadClass.h"
#include "AnsiString.h"

#define MAXBUFLEN 1460
#define SERVERMODE true
#define CLIENTMODE false
#define MSG_NETWORKCLOSED     65000
#define MSG_NETWORKCONNECTED  65001

//the owner window
static HWND OwnerHwnd=HWND_BROADCAST;

#define REGNETWCALLBK(W,X) \
OwnerHwnd=W;\
if(command==X)

#define DEFAULT_BUFLEN 2048

class TNetworkIface : public Thread
{
private:
   bool    ServerMode;
   
   WSADATA wsaData;
   int     iResult;
   
   SOCKET  ListenSocket;
   SOCKET  ClientSocket;

   struct  addrinfo *result;
   struct  addrinfo *ptr;
   struct  addrinfo hints;

   int     iSendResult;
   char*   recvbuf;
   int     recvbuflen;
   
   bool    connected;    //server and client is connected, communication is established
   
protected:
   void __fastcall Execute();
   void __fastcall SocketErrorHandler( int ErrCode, char* errMSG );
public:
   __fastcall TNetworkIface( bool IsServerMode, AnsiString AIP, AnsiString APort );
   __fastcall ~TNetworkIface( );
   bool __fastcall SendData( int ASize, char* AData);
   
   //callback function virtually declared in ThreadClass, must be defined outside
   void OnTerminate();
   //callback functions that must be defined outside
   void OnReceiveDataEvent(char* AData, int ASize);
   void OnReceiveStringEvent(AnsiString &AMsg);
   void OnNetworkErrorEvent(int ErrCode, AnsiString &AMsg);
};
#endif
