//TGroupBox
#ifndef TGroupBoxH
#define TGroupBoxH

#include <windows.h>

static WNDPROC GroupBoxProcAddr;

class TGroupBox{
	HFONT hFont;
	HWND GRhwnd;
public:
	TGroupBox(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size);
	~TGroupBox();
	void SetDefFont();
	
    static LRESULT CALLBACK StatWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
		switch (Msg){
			case WM_KEYDOWN:	          //Keyboard
				SendMessage(GetParent(hWnd),WM_KEYDOWN,wParam,lParam);
				break;
     
			case WM_CHAR:                 //Keyboard char
				SendMessage(GetParent(hWnd),WM_CHAR,wParam,lParam);
				break;
				
			case WM_GETDLGCODE:
				if(wParam==VK_RETURN)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,13,0);
				if(wParam==VK_TAB)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_TAB,0);
				if(wParam==VK_ESCAPE)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_ESCAPE,0);
				break;
		}
		return CallWindowProc (GroupBoxProcAddr,hWnd, Msg, wParam, lParam);
    }
	
};

#endif
