//TRadioButton
#ifndef TRadioButtonH
#define TRadioButtonH

#include <windows.h>
#include "properties.h"

static WNDPROC RadioButtonProcAddr;

class TRadioButton{
    HWND RadioBoxHwnd;
    bool CheckedState;
	HFONT hFont;
	HWND hwnd;
  public:
    int ID;
    TRadioButton(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size);
    ~TRadioButton();
      
    property<TRadioButton, bool> Checked;
    void SetChecked(const bool & ckh);
    const bool & GetChecked() const;
    bool & GetRefChecked();
	void Check(bool state);
	void SetDefFont();
	
    static LRESULT CALLBACK StatWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
		switch (Msg){
			case WM_KEYDOWN:	          //Keyboard
				SendMessage(GetParent(hWnd),WM_KEYDOWN,wParam,lParam);
				break;
     
			case WM_CHAR:                 //Keyboard char
				SendMessage(GetParent(hWnd),WM_CHAR,wParam,lParam);
				break;
				
			case WM_GETDLGCODE:
				if(wParam==VK_RETURN)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,13,0);
				if(wParam==VK_TAB)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_TAB,0);
				if(wParam==VK_ESCAPE)
					SendMessage(GetParent(hWnd),WM_KEYDOWN,VK_ESCAPE,0);
				break;
		}
		return CallWindowProc (RadioButtonProcAddr,hWnd, Msg, wParam, lParam);
    }
	
};
#endif
